import datetime
import autopath
from os.path import join
import subprocess

from eoleaaf.config import dbtype
from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.parsedelta import main as main_delta
from eoleaaf.aaf import reset_db


reset_db()


data = join(autopath.HERE, 'data')

keys = set(['ENTPersonFonctions', 'uid', 'personalTitle', 'ENTPersonNomPatro', 'FieldFromXMLImportActionDate', 'ENTAuxEnsMEF', 'FieldModifiedStatus', 'ENTPersonJointure', 'ENTAuxEnsClassesMatieres', 'PersEducNatPresenceDevantEleves', 'ENTAuxEnsMatiereEnseignEtab', 'sn', 'ENTPersonStructRattach', 'mail', 'id', 'ENTPersonDateNaissance', 'givenName', 'FieldToLDIFFExportActionDate', 'userPassword', 'ENTAuxEnsClasses', 'FieldActionType'])

if dbtype == 'mongodb':
    keys |= set([u'UserType', u'_id', u'ENTPersonLogin', u'gecos'])
    keys -= set(['FieldToLDIFFExportActionDate'])

expected = {'ENTPersonFonctions': '2729$ORI$ORIENTATION$O0040$ORIENTATION', 'uid': 'AUL14655', 'ENTAuxEnsClassesMatieres': None, 'FieldFromXMLImportActionDate': datetime.datetime(2014, 5, 27, 10, 39, 50), 'userPassword': 'OTVOHUGI', 'ENTAuxEnsMEF': None, 'FieldModifiedStatus': 1, 'ENTPersonJointure': '111111', 'ENTPersonNomPatro': 'MAUF', 'PersEducNatPresenceDevantEleves': 'N', 'givenName': 'ALBERTINE', 'ENTAuxEnsMatiereEnseignEtab': None, 'sn': 'MAUF', 'ENTPersonStructRattach': None, 'ENTPersonDateNaissance': '11/11/1911', 'mail': 'albertine.MAUF@ac-dijon.fr', 'personalTitle': 'Mme', 'FieldToLDIFFExportActionDate': None, 'id': '111111', 'ENTAuxEnsClasses': None, 'FieldActionType': 'CREATE'}

def test_20140129():
    path_aaf_complet = join(data, '20140129', 'aaf-complet')
    main(path_aaf_complet, maj_mode=False, close=False)

    before = list(db.fetchall('user', 'UserType', 'administratif'))[0]
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)

    path_aaf_delta = join(data, '20140129', 'aaf-delta')
    main_delta(path_aaf_delta, close=False)

    after = list(db.fetchall('user', 'UserType', 'administratif'))[0]
    keys_before = [unicode(c) for c in before.keys()]
    keys_before = set(keys_before)
    keys_after = set(after.keys())


    assert keys_before == keys_after
    assert keys_after == keys

    for key in keys_before:
        if key == 'FieldFromXMLImportActionDate':
            continue
        if key == 'mail':
            assert before[key] == expected[key] #'albertine.MAUF@ac-dijon.fr'
            assert after[key] == 'AM@ac-dijon.fr'
        elif key == 'ENTPersonDateNaissance':
            assert before[key] == expected[key] #'11/11/1911'
            assert after[key] == '12/12/1912'
        elif key == 'FieldActionType':
            assert before[key] == 'CREATE'
            assert after[key] == 'DELTAUPDATE'
        else:
            assert before[key] == after[key]

