# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId

from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.aaf import reset_db

def setup_function(module, ):
    reset_db()



data_complet = join(autopath.HERE, 'data', '20170704', 'complet-maj', 'aaf-complet')
data_complet_maj = join(autopath.HERE, 'data', '20170704', 'complet-maj', 'aaf-complet-maj')


# created in complet then inserted in the AD
# unchanged in complet-maj
eleve = {u"ENTPersonJointure": "14357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "albertine.delacourt01",
         u'FieldActionType': 'CREATE_DONE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Albertine",
         u"ENTPersonAutresPrenoms": [u"Albertine", u"Pauline"],
         u"personalTitle": "Mme.",
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994845$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "EXTERNE LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         u"ENTEleveGroupes": [],
         u'gecos': 'DELACOURT Albertine'
         }

# created in complet then inserted in the AD
# changed in complet-maj 
eleve2 = copy(eleve)
eleve2[u"ENTEleveMEF"] = u"21220008111"
eleve2[u"ENTPersonLogin"] = u'albertine.delacourt02'
eleve2[u"ENTPersonJointure"] = u"14358"
eleve2[u'FieldActionType'] = 'DELTAUPDATE'
eleve2[u"ENTPersonDateNaissance"] = "28/11/1915"

# created in complet then inserted in the AD
# do not exist in complet-maj
eleve3 = copy(eleve)
eleve3[u"ENTEleveMEF"] = u"21221118111"
eleve3[u"ENTPersonLogin"] = u'albertine.delacourt03'
eleve3[u"ENTPersonJointure"] = u"14359"
eleve3[u'FieldActionType'] = 'DELTADELETE'

# created in complet-maj
eleve4 = copy(eleve)
eleve4[u"ENTEleveMEF"] = u"21221118110"
eleve4[u"ENTPersonLogin"] = u'sandrine.delacourt01'
eleve4[u"ENTPersonJointure"] = u"14375"
eleve4[u'FieldActionType'] = 'DELTACREATE'
eleve4[u'gecos'] = 'DELACOURT Sandrine'
eleve4[u'ENTPersonAutresPrenoms'] = ['Sandrine', 'Pauline']
eleve4[u'givenName'] = 'Sandrine'

eleves = {u'21220008110': eleve,
          u'21220008111': eleve2,
          u'21221118111': eleve3,
          u'21221118110': eleve4
         }


# created in complet then inserted in the AD
# unchanged in complet-maj
responsable = {u"ENTPersonJointure": "994845",
               u"ENTPersonDateNaissance": '',
               u"ENTPersonNomPatro": "DELACOURT",
               u"sn": "DELACOURT",
               u"givenName": "Mathieu",
               u"personalTitle": "M",
               u"homePhone": "+33 0 00 11 22 33",
               u"telephoneNumber": '',
               u"ENTPersonAdresse": "2 ROUTE DE CHARTRES",
               u"ENTPersonCodePostal": "75000",
               u"ENTPersonVille": "PARIS",
               u"ENTPersonPays": "FRANCE",
               u"ENTPersonLogin": "mathieu.delacourt01",
               u'FieldActionType': 'CREATE_DONE',
               u'FieldModifiedStatus': 1,
               u'UserType': "responsable",
               u'gecos': 'DELACOURT Mathieu'
}

# created in complet then inserted in the AD
# changed in complet-maj 
responsable3 = copy(responsable)
responsable3[u'ENTPersonJointure'] = u'994846'
responsable3[u"personalTitle"] = "Mme"
responsable3[u"givenName"] = "Jeanne"
responsable3[u"ENTPersonLogin"] = "jeanne.delacourt01"
responsable3[u'homePhone'] = u'+33 0 00 11 22 35'
responsable3[u'gecos'] = 'DELACOURT Jeanne'
responsable3[u'FieldActionType'] = 'DELTAUPDATE'

# created in complet then inserted in the AD
# do not exist in complet-maj
responsable5 = copy(responsable)
responsable5[u'ENTPersonJointure'] = u'994445'
responsable5[u"givenName"] = "Philippe"
responsable5[u"ENTPersonLogin"] = "philippe.delacourt01"
responsable5[u'homePhone'] = u'+33 0 00 11 22 35'
responsable5[u'gecos'] = 'DELACOURT Philippe'
responsable5[u'FieldActionType'] = 'DELTADELETE'

# created in complet-maj
responsable6 = copy(responsable3)
responsable6[u'ENTPersonJointure'] = u'994847'
responsable6[u"ENTPersonLogin"] = "jeanne.delacourt02"
responsable6[u'FieldActionType'] = 'DELTACREATE'


responsables = {u'994845': responsable,
                u'994846': responsable3,
                u'994445': responsable5,
                u'994847': responsable6,
}


prof = {
    u"ENTPersonJointure": "163",
    u"ENTPersonDateNaissance": "06/01/1918",
    u"ENTPersonNomPatro": "DELMARE",
    u"ENTPersonLogin": "ghislaine.delmare01",
    u'FieldActionType': 'CREATE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELMARE",
    u"givenName": "GHISLAINE",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delmare@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "DELMARE Ghislaine"
    }

prof2 = copy(prof)
prof2[u"ENTPersonJointure"] = "164"
prof2[u"ENTPersonDateNaissance"] = "06/01/1922"
prof2[u'FieldActionType'] = 'DELTAUPDATE'
prof2[u"ENTPersonLogin"] = "ghislaine.delmare02"

prof3 = copy(prof)
prof3[u"ENTPersonJointure"] = "165"
prof3[u'FieldActionType'] = 'DELTADELETE'
prof3[u"ENTPersonLogin"] = "ghislaine.delmare03"

prof4 = copy(prof)
prof4[u"ENTPersonJointure"] = "168"
prof4[u'FieldActionType'] = 'DELTACREATE'
prof4[u"ENTPersonDateNaissance"] = "06/01/1922"
prof4[u"ENTPersonLogin"] = "ghislaine.delmare04"

profs = {
        "163": prof,
        "164": prof2,
        "165": prof3,
        "168": prof4,
        }

# created in complet then inserted in the AD
# unchanged in complet-maj
administratif = {
    u"ENTPersonJointure": "34",
    u"ENTPersonDateNaissance": "04/09/1985",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled01",
    u'FieldActionType': 'CREATE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "DUBLED",
    u"givenName": "ANNIE",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    #u"ENTPersonFonctions": "2515$ORI$ORIENTATION$O0040$ORIENTATION",
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "DUBLED Annie"
}


# created in complet then inserted in the AD
# changed in complet-maj 
administratif2 = copy(administratif)
administratif2[u"ENTPersonJointure"] = "35"
administratif2[u'FieldActionType'] = 'DELTAUPDATE'
administratif2[u"ENTPersonLogin"] = "annie.dubled02"
administratif2[u"ENTPersonDateNaissance"] = "04/09/1986"

# created in complet then inserted in the AD
# do not exist in complet-maj
administratif3 = copy(administratif)
administratif3[u"ENTPersonJointure"] = "36"
administratif3[u'FieldActionType'] = 'DELTADELETE'
administratif3[u"ENTPersonLogin"] = "annie.dubled03"

# created in complet-maj
administratif4 = copy(administratif)
administratif4[u"ENTPersonJointure"] = "37"
administratif4[u'FieldActionType'] = 'DELTACREATE'
administratif4[u"ENTPersonLogin"] = "annie.dubled04"


administratifs = {
                  '34': administratif,
                  '35': administratif2,
                  '36': administratif3,
                  '37': administratif4,
                  }

etablissement = {
    u"ENTStructureJointure": "2515",
    u"ENTStructureUAI": "00000001",
    u"ENTEtablissementUAI": "00000001",
    u"ENTStructureSIREN": "17450234560289",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'CREATE_DONE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    u"telephoneNumber": "+33 211 25 687  00",
    u"facsimileTelephoneNumber": "+33 2 125899 20 01",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissement2 = {
    u"ENTStructureJointure": "2516",
    u"ENTStructureUAI": "00000002",
    u"ENTEtablissementUAI": "00000002",
    u"ENTStructureSIREN": "17450234560290",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTADELETE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    u"telephoneNumber": "+33 211 25 687  01",
    u"facsimileTelephoneNumber": "+33 2 125899 20 02",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissement3 = {
    u"ENTStructureJointure": "2517",
    u"ENTStructureUAI": "00000003",
    u"ENTEtablissementUAI": "00000003",
    u"ENTStructureSIREN": "17450234560291",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    u"telephoneNumber": "+33 211 25 687  03",
    u"facsimileTelephoneNumber": "+33 2 125899 20 04",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissement4 = {
    u"ENTStructureJointure": "2518",
    u"ENTStructureUAI": "00000005",
    u"ENTEtablissementUAI": "00000005",
    u"ENTStructureSIREN": "17450234560295",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTAUPDATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    u"telephoneNumber": "+33 211 25 687  01",
    u"facsimileTelephoneNumber": "+33 2 125899 20 010",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}
etablissements = {
        '2515': etablissement,
        '2516': etablissement2,
        '2517': etablissement3,
        '2518': etablissement4
        }

# created in complet then inserted in the AD
# unchanged in complet-maj
subject = {
        u"ENTMatJointure": '308600',
        u"ENTLibelleMatiere": 'ANGLAIS',
        u'FieldActionType': 'CREATE_DONE',
        u'FieldModifiedStatus': 1
        }

# created in complet then inserted in the AD
# changed in complet-maj 
subject3 = {
        u"ENTMatJointure": '308603',
        u"ENTLibelleMatiere": 'LATIN',
        u'FieldActionType': 'DELTAUPDATE',
        u'FieldModifiedStatus': 1
        }

# created in complet then inserted in the AD
# do not exist in complet-maj
subject4 = {
        u"ENTMatJointure": '308604',
        u"ENTLibelleMatiere": 'TURC',
        u'FieldActionType': 'DELTADELETE',
        u'FieldModifiedStatus': 1
        }

# created in complet-maj
subject5 = {
        u"ENTMatJointure": '308605',
        u"ENTLibelleMatiere": 'INDONESIEN',
        u'FieldActionType': 'DELTACREATE',
        u'FieldModifiedStatus': 1
        }

subjects = {
        '308600': subject,
        '308603': subject3,
        '308604': subject4,
        '308605': subject5
        }


def test_etablissements():
    keys = set(etablissement.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('etablissement'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['etablissement'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('etablissement')
    list_etablissements = etablissements.keys()
    for res in result:
        idx = res['ENTStructureJointure']
        print "etablissement", idx
        list_etablissements.remove(idx)
        assert keys == set(res.keys())
        for key in etablissements[idx].keys():
            assert res[key] == etablissements[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert not list_etablissements


def test_subjects():
    keys = set(subject.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('subject'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['subject'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('subject')
    list_subjects = subjects.keys()
    for res in result:
        idx = res['ENTMatJointure']
        print "subject", idx
        list_subjects.remove(idx)
        assert keys == set(res.keys())
        for key in subjects[idx].keys():
            assert res[key] == subjects[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert not list_subjects


def test_profs():
    objectid = 'ENTPersonStructRattach'
    relations = [(u'ENTAuxEnsMatiereEnseignEtab', ['ANGLAIS LV1']),
                 (u"ENTAuxEnsClasses", ["4E3", "5E2", "5E3", "5E4", "6E1", "6E2"]),
                 (u"ENTAuxEnsClassesPrincipal", ["4E3"]),
                 (u"ENTAuxEnsGroupes", ["4E3_A"]),
                 (u"ENTAuxEnsMEF", ["4EME", "4EME SECTION EUROPEENNE", "5EME", "6EME"]),
                 (u'ENTPersonFonctions', (['ENSEIGNEMENT'], ['ANGLAIS'])),
                 (u"ENTAuxEnsClassesMatieres", ["4E3", "5E2", "5E3", "5E4", "6E1", "6E2"]),
                 (u"ENTAuxEnsGroupesMatieres", ["4E3_A"]),
                 ]
    keys = set(prof.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set([objectid])
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('user', 'UserType', 'enseignant')
    list_profs = profs.keys()
    for res in result:
        idx = res['id']
        print "professeur", idx
        assert keys == set(res.keys())
        for key in profs[idx].keys():
            assert res[key] == profs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
        list_profs.remove(idx)
    assert not list_profs


def test_administratifs():
    relations = [(u'ENTPersonFonctions', (['ORIENTATION'], ['ORIENTATION']))
                 ]
    keys = set(administratif.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id'])
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('user', 'UserType', 'administratif')
    list_admins = administratifs.keys()
    for res in result:
        idx = res['id']
        print "administratif", idx
        list_admins.remove(idx)
        assert keys == set(res.keys())
        for key in administratifs[idx].keys():
            assert res[key] == administratifs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['function'] == values[0][0]
            assert res[relation]['discipline'] == values[1][0]
    assert not list_admins


def test_responsables():
    keys = set(responsable.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('user', 'UserType', 'responsable')
    list_resps = responsables.keys()
    for res in result:
        idx = res[u'ENTPersonJointure']
        print "responsable numero", idx
        list_resps.remove(idx)
        assert keys == set(res.keys())
        for key in responsable.keys():
            assert res[key] == responsables[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert not list_resps


def test_eleves():
    objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
    relations = [(u'ENTEleveClasses', ['00000001_T STL'])]
    keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set(objectids)
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main(data_complet_maj, True)
    result = db.fetchall('user', 'UserType', 'eleve')
    list_students = eleves.keys()
    for res in result:
        idx = res[u'ENTEleveMEF']
        print "eleve numero", idx
        assert keys == set(res.keys())
        for key in eleve.keys():
            if key != 'ENTEleveCodeEnseignements':
                assert res[key] == eleves[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            else:
                assert res[key][0] == u'010300'
                assert isinstance(res[key][1], ObjectId)
        list_students.remove(idx)
        for objectid in objectids:
            values = res[objectid]
            if isinstance(values, list):
                for val in values:
                    assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                    #FIXME bon parent ?
            else:
                assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['etablissement'] == res['ENTPersonStructRattach']
            assert res[relation]['name'] == values[0]
    assert not list_students
