# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId

from eoleaaf.aaf import reset_db
from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.parsedelta import main as main_delta
from eoleaaf.sambatranslator import erase_db

data = join(autopath.HERE, 'data', '20170704')

data_complet = join(data, 'matrix', 'aaf-complet')
data_delta1 = join(data, 'matrix', 'aaf-delta-etap1')
data_delta2 = join(data, 'matrix', 'aaf-delta-etap2')


def setup_function(module, ):
    reset_db()
    erase_db()

eleve = {u"ENTPersonJointure": "14357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "albertine.delacourt02",
         u'FieldActionType': 'DELTACREATE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Albertine",
         u"ENTPersonAutresPrenoms": [u"Albertine", u"Pauline"],
         u"personalTitle": "Mme.",
#         u"ENTEleveParents": [u"994845", u"994846"],
#         u"ENTElevePere": "994845",
#         u"ENTEleveMere": "994846",
#         u"ENTEleveAutoriteParentale": [u"994845", u"994846"],
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         #FIXME donnee brute utile a extraire ? => http://media.eduscol.education.fr/file/ENT/27/9/Documentation-solutionsENT-evolutionsAAF-SDETv4_238279.pdf
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "INTERNE PAS LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         #u"ENTPersonStructRattach": "2515",
         #u"ENTEleveClasses": "2515$T STL",
         u"ENTEleveGroupes": [],
         u"gecos": "DELACOURT Albertine"
         }

eleve2 = copy(eleve)
eleve2[u"ENTPersonDateNaissance"] = "28/11/1994"
eleve3 = copy(eleve)
eleve3[u"ENTEleveRegime"] = "EXTERNE LIBRE"
eleve3[u"ENTElevePersRelEleve"] = [u"994885$1$0$2$1$0", u"994886$2$1$1$1$0"]
eleve3[u"ENTEleveMEF"] = u"21221118110"
eleve3[u"ENTPersonLogin"] = u'albertine.delacourt04'
eleve3[u"ENTPersonJointure"] = u"14359"
eleve3[u'FieldActionType'] = 'DELTADELETE'

eleve4 = copy(eleve3)
eleve4[u"ENTPersonDateNaissance"] = "28/11/1984"

eleves = {
          'delta1': {u'21220008110': eleve,
                     u'21221118110': eleve3},
          'delta2': {u'21220008110': eleve2,
                     u'21221118110': eleve4}
          }


etablissement = {
    u"ENTStructureJointure": "2515",
    u"ENTStructureUAI": "00000001",
    u"ENTEtablissementUAI": "00000001",
    u"ENTStructureSIREN": "17450234560289",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    u"telephoneNumber": "+33 211 25 687  01",
    u"facsimileTelephoneNumber": "+33 2 125899 20 01",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}
etablissement2 = copy(etablissement)
etablissement2[u"telephoneNumber"] = "+33 211 25 687  02"
etablissements = {
        "delta1": {u'2515': etablissement},
        "delta2": {u'2515': etablissement2}
        }

subject = {
        u"ENTMatJointure": '308603',
        u"ENTLibelleMatiere": 'ESPAGNOL',
        u'FieldActionType': 'DELTACREATE',
        u'FieldModifiedStatus': 1
        }
subject2 = copy(subject)
subject2[u"ENTLibelleMatiere"] = 'ITALIEN'

subjects = {
            'delta1': {'308603': subject},
            'delta2': {'308603': subject2}
        }

def test_etablissement_delta1():
    keys = set(etablissement.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    result = db.fetchall('etablissement')
    list_etablissement = etablissements['delta1'].keys()
    for res in result:
        idx = res['id']
        if idx not in etablissements['delta1']:
            continue
        print "etablissement", idx
        list_etablissement.remove(idx)
        assert keys == set(res.keys())
        for key in etablissement.keys():
            assert res[key] == etablissements['delta1'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_etablissement == []


def test_etablissement_delta2():
    keys = set(etablissement.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    main_delta(data_delta2, close=False)
    result = db.fetchall('etablissement')
    list_etablissement = etablissements['delta2'].keys()
    for res in result:
        idx = res['id']
        if idx not in etablissements['delta2']:
            continue
        print "etablissement", idx
        list_etablissement.remove(idx)
        assert keys == set(res.keys())
        for key in etablissement.keys():
            assert res[key] == etablissements['delta2'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_etablissement == []


def test_subject_delta1():
    keys = set(subject.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    list_subjects = subjects['delta1'].keys()
    result = db.fetchall('subject')
    for res in result:
        idx = res['id']
        if idx not in subjects['delta1']:
            continue
        print "subject", idx
        assert keys == set(res.keys())
        list_subjects.remove(idx)
        for key in subject.keys():
            assert res[key] == subjects['delta1'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_subjects == []


def test_subject_delta2():
    keys = set(subject.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    main_delta(data_delta2, close=False)
    list_subjects = subjects['delta2'].keys()
    result = db.fetchall('subject')
    for res in result:
        idx = res['id']
        if idx not in subjects['delta2']:
            continue
        print "subject", idx
        assert keys == set(res.keys())
        list_subjects.remove(idx)
        for key in subject.keys():
            assert res[key] == subjects['delta2'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_subjects == []


def test_eleves_delta1():
    objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
    relations = [(u'ENTEleveClasses', ['00000001_T STL'])]
    keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set(objectids)
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    result = db.fetchall('user', 'UserType', 'eleve')
    for res in result:
        idx = res[u'ENTEleveMEF']
        if idx not in eleves['delta1']:
            if idx in ['21220008111']:
                continue
            raise Exception('unknown student', idx)
        print "eleve numero", idx
        assert keys == set(res.keys())
        for key in eleve.keys():
            if key != 'ENTEleveCodeEnseignements':
                assert res[key] == eleves['delta1'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
            else:
                assert res[key][0] == u'010300'
                assert isinstance(res[key][1], ObjectId)
        for objectid in objectids:
            values = res[objectid]
            if isinstance(values, list):
                for val in values:
                    assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                    #FIXME bon parent ?
            else:
                assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['etablissement'] == res['ENTPersonStructRattach']
            assert res[relation]['name'] == values[0]


def test_eleves_delta2():
    objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
    relations = [(u'ENTEleveClasses', ['00000001_T STL'])]
    keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set(objectids)
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, close=False)
    main_delta(data_delta1, close=False)
    main_delta(data_delta2, close=False)
    result = db.fetchall('user', 'UserType', 'eleve')
    for res in result:
        idx = res[u'ENTEleveMEF']
        if idx not in eleves['delta2']:
            if idx in ['21220008111']:
                continue
            raise Exception('unknown student', idx)
        print "eleve numero", idx
        assert keys == set(res.keys())
        for key in eleve.keys():
            if key != 'ENTEleveCodeEnseignements':
                assert res[key] == eleves['delta2'][idx][key], u"la valeur correspondant à : {} est différente".format(key)
            else:
                assert res[key][0] == u'010300'
                assert isinstance(res[key][1], ObjectId)
        for objectid in objectids:
            values = res[objectid]
            if isinstance(values, list):
                for val in values:
                    assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                    #FIXME bon parent ?
            else:
                assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['etablissement'] == res['ENTPersonStructRattach']
            assert res[relation]['name'] == values[0]
