# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId
import logging
import ldb

from eoleaaf.aaf import reset_db
from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.parsedelta import main as main_delta
from eoleaaf.sambatranslator import SambaToplevel, SambaSplit, erase_db

# get BASEDN and AD_REALM
exec(file('/etc/eole/samba4-vars.conf').read())

data = join(autopath.HERE, 'data', '20170704', 'updateuser')

data_complet = join(data, 'aaf-complet')
data_delta = join(data, 'aaf-delta')

def setup_function(module, ):
    reset_db()
    erase_db()


eleve = {u"ENTPersonJointure": "14357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DURANT",
         u"sn": "DURANT",
         u"ENTPersonLogin": "albertine.delacourt02",
         u'FieldActionType': 'DELTAUPDATE_DONE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Albertine",
         u"ENTPersonAutresPrenoms": [u"Albertine", u"Pauline"],
         u"personalTitle": "Mme.",
#         u"ENTEleveParents": [u"994845", u"994846"],
#         u"ENTElevePere": "994845",
#         u"ENTEleveMere": "994846",
#         u"ENTEleveAutoriteParentale": [u"994845", u"994846"],
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         #FIXME donnee brute utile a extraire ? => http://media.eduscol.education.fr/file/ENT/27/9/Documentation-solutionsENT-evolutionsAAF-SDETv4_238279.pdf
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "INTERNE PAS LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         #u"ENTPersonStructRattach": "2515",
         #u"ENTEleveClasses": "2515$T STL",
         u"ENTEleveGroupes": [],
         u"gecos": "DURANT Albertine"
         }


eleve_ad_toplevel = {
        "dn": ['CN=albertine.delacourt02,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'person', 'organizationalPerson', 'user'],
        "cn": ['albertine.delacourt02'],
        "givenName": ['DURANT Albertine'],
        "instanceType": ['4'],
#        "whenCreated": ['20171005092059.0Z']
#"whenChanged ['20171005092059.0Z']
        "displayName": ['DURANT Albertine'],
        #"uSNCreated": ['5447'],
        "name": ['albertine.delacourt02'],
#"objectGUID ['\\\x0c+>;}9G\x82x\t\xaa\xfb\x99)\xbe']
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
#"objectSid ['\x01\x05\x00\x00\x00\x00\x00\x05\x15\x00\x00\x00\x97@\x08\xad\xb7\x87\x8c\xcf\xd4NE\xb9\xb4\x05\x00\x00']
#"accountExpires ['9223372036854775807']
        "logonCount": ['0'],
        "sAMAccountName": ['albertine.delacourt02'],
#"sAMAccountType ['805306368']
        "userPrincipalName": ['albertine.delacourt02@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "gecos": ['DURANT Albertine'],
#"pwdLastSet": ['131516688594070810']
        "userAccountControl": ['512'],
#"uSNChanged ['5450']
        "memberOf": ['CN=eleve,CN=Users,{}'.format(BASEDN), 'CN=00000001_eleve,CN=Users,{}'.format(BASEDN), 'CN=00000001,CN=Users,{}'.format(BASEDN), 'CN=00000001_T STL,CN=Users,{}'.format(BASEDN)],
        "distinguishedName": ['CN=albertine.delacourt02,CN=Users,{}'.format(BASEDN)]
        }

eleve_ad_split = copy(eleve_ad_toplevel)
eleve_ad_split['dn'] = ['CN=albertine.delacourt02,OU=00000001,{}'.format(BASEDN)]
eleve_ad_split['memberOf'] = ['CN=eleve,CN=Users,{}'.format(BASEDN), 'CN=00000001_eleve,OU=00000001,{}'.format(BASEDN), 'CN=00000001,OU=00000001,{}'.format(BASEDN), 'CN=00000001_T STL,OU=00000001,{}'.format(BASEDN)]
eleve_ad_split['distinguishedName'] = eleve_ad_split['dn']

eleves = {u'21220008110': eleve}

eleves_ad_toplevel = {u'21220008110': eleve_ad_toplevel}
eleves_ad_split = {u'21220008110': eleve_ad_split}


prof = {
    u"ENTPersonJointure": "163",
    u"ENTPersonDateNaissance": "06/01/1919",
    u"ENTPersonNomPatro": "DELAMARCHE",
    u"ENTPersonLogin": "ghislaine.delmare01",
    u'FieldActionType': 'DELTAUPDATE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELAMARCHE",
    u"givenName": "GHISLAINE",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delamarche@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "DELAMARCHE Ghislaine"
    }


prof_ad = {
        "dn": ['CN=ghislaine.delmare01,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'person', 'organizationalPerson', 'user'],
        "cn": ['ghislaine.delmare01'],
        "instanceType": ['4'],
        "name": ['ghislaine.delmare01'],
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
        "logonCount": ['0'],
        "sAMAccountName": ['ghislaine.delmare01'],
        "userPrincipalName": ['ghislaine.delmare01@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "userAccountControl": ['512'],
        "memberOf": ['CN=00000001,CN=Users,{}'.format(BASEDN), 'CN=00000001_enseignant,CN=Users,{}'.format(BASEDN), 'CN=enseignant,CN=Users,{}'.format(BASEDN)],
        "givenName": ['DELAMARCHE Ghislaine'],
        "displayName": ['DELAMARCHE Ghislaine'],
        "gecos": ['DELAMARCHE Ghislaine'],
        "distinguishedName": ['CN=ghislaine.delmare01,CN=Users,{}'.format(BASEDN)]
        }

prof_ad_split = copy(prof_ad)
prof_ad_split['dn'] = ['CN=ghislaine.delmare01,OU=00000001,{}'.format(BASEDN)]
prof_ad_split['memberOf'] = ['CN=00000001,OU=00000001,{}'.format(BASEDN), 'CN=00000001_enseignant,OU=00000001,{}'.format(BASEDN), 'CN=enseignant,CN=Users,{}'.format(BASEDN)]
prof_ad_split['distinguishedName'] = prof_ad_split['dn']

profs = {
        u'163': prof
        }

profs_ad_toplevel = {u'163': prof_ad}
profs_ad_split = {u'163': prof_ad_split}


administratif = {
    u"ENTPersonJointure": "34",
    u"ENTPersonDateNaissance": "04/09/1986",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled01",
    u'FieldActionType': 'DELTAUPDATE_DONE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "MARTIN",
    u"givenName": "ANNIE",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    #u"ENTPersonFonctions": "2515$ORI$ORIENTATION$O0040$ORIENTATION",
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "MARTIN Annie"
}

administratifs = {'34': administratif}

administratif_ad_toplevel = {
        "dn": ['CN=annie.dubled01,CN=Users,{}'.format(BASEDN)],
        "objectClass": ['top', 'person', 'organizationalPerson', 'user'],
        "cn": ['annie.dubled01'],
        "givenName": ['MARTIN Annie'],
        "instanceType": ['4'],
        "displayName": ['MARTIN Annie'],
        "name": ['annie.dubled01'],
        "badPwdCount": ['0'],
        "codePage": ['0'],
        "countryCode": ['0'],
        "badPasswordTime": ['0'],
        "lastLogoff": ['0'],
        "lastLogon": ['0'],
        "primaryGroupID": ['513'],
        "logonCount": ['0'],
        "sAMAccountName": ['annie.dubled01'],
        "userPrincipalName": ['annie.dubled01@{}'.format(AD_REALM)],
        "objectCategory": ['CN=Person,CN=Schema,CN=Configuration,{}'.format(BASEDN)],
        "gecos": ['MARTIN Annie'],
        "userAccountControl": ['512'],
        "memberOf": ['CN=administratif,CN=Users,{}'.format(BASEDN)],
        "distinguishedName": ['CN=annie.dubled01,CN=Users,{}'.format(BASEDN)]
}

administratif_ad_split = copy(administratif_ad_toplevel)
#administratif_ad_split['dn'] =  ['CN=annie.dubled01,OU=00000001,{}'.format(BASEDN)]
#administratif_ad_split['distinguishedName'] = administratif_ad_split['dn']

administratifs_ad_toplevel = {'34': administratif_ad_toplevel}
administratifs_ad_split = {'34': administratif_ad_split}


def test_prof():
    for mode, profs_ad, SambaExport in [('toplevel', profs_ad_toplevel, SambaToplevel), ('split', profs_ad_split, SambaSplit)]:
        setup_function(None)
        objectid = 'ENTPersonStructRattach'
        relations = [(u'ENTAuxEnsMatiereEnseignEtab', ['00000001_ANGLAIS LV1']),
                     (u"ENTAuxEnsClasses", ["00000001_4E3", "00000001_5E2", "00000001_5E3", "00000001_5E4", "00000001_6E1", "00000001_6E2"]),
                     (u"ENTAuxEnsClassesPrincipal", ["00000001_4E3"]),
                     (u"ENTAuxEnsGroupes", ["00000001_4E3_A"]),
                     (u"ENTAuxEnsMEF", ["00000001_4EME", "00000001_4EME SECTION EUROPEENNE", "00000001_5EME", "00000001_6EME"]),
                     (u'ENTPersonFonctions', (['ENSEIGNEMENT'], ['ANGLAIS'])),
                     (u"ENTAuxEnsClassesMatieres", ["4E3", "5E2", "5E3", "5E4", "6E1", "6E2"]),
                     (u"ENTAuxEnsGroupesMatieres", ["4E3_A"]),
                     ]
        keys = set(prof.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate']) | set([objectid])
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main_delta(data_delta, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'enseignant')
        list_profs = profs.keys()
        for res in result:
            idx = res['id']
            if idx not in profs.keys():
                continue
            list_profs.remove(idx)
            print "professeur", idx, 'en mode', mode
            assert keys == set(res.keys())
            for key in prof.keys():
                assert res[key] == profs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            etab = res[objectid]
            assert isinstance(etab, ObjectId), u"{} n'est pas une relation".format(objectid)

            for relation, values in relations:
                assert relation in res
                if relation == u"ENTAuxEnsClassesMatieres":
                    for idx_, rel in enumerate(res[relation]):
                        assert rel['class'] == values[idx_]
                        assert isinstance(rel['subject'], ObjectId)
                elif relation == u"ENTAuxEnsGroupesMatieres":
                    assert res[relation]['group'] == values[0]
                    assert isinstance(res[relation]['subject'], ObjectId)
                else:
                    if isinstance(res[relation], list):
                        for idx_, rel in enumerate(res[relation]):
                            assert isinstance(rel['etablissement'], ObjectId)
                            assert rel['etablissement'] == etab
                            assert rel['name'] == values[idx_]
                    else:
                        assert isinstance(res[relation]['etablissement'], ObjectId)
                        assert res[relation]['etablissement'] == etab
                        if isinstance(values, tuple):
                            assert res[relation]['function'] == values[0][0]
                            assert res[relation]['discipline'] == values[1][0]
                        else:
                            assert res[relation]['name'] == values[0]
            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            assert len(query_result) == 1
            list_keys = profs_ad[idx].keys()
            for key, value in query_result[0].items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        values.append(i)
                assert set(values) == set(profs_ad[idx][key]), u"valeurs différentes pour la clef : {}".format(key)
            assert not list_keys
        assert list_profs == []


def test_administratif():
    for mode, administratifs_ad, SambaExport in [('toplevel', administratifs_ad_toplevel, SambaToplevel), ('split', administratifs_ad_split, SambaSplit)]:
        setup_function(None)
        relations = [(u'ENTPersonFonctions', (['ORIENTATION'], ['ORIENTATION']))
                     ]
        keys = set(administratif.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate'])
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main_delta(data_delta, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'administratif')
        list_administratifs = administratifs.keys()
        for res in result:
            idx = res[u'ENTPersonJointure']
            if idx not in administratifs:
                continue
            print "administratif", idx, 'en mode', mode
            list_administratifs.remove(idx)
            assert keys == set(res.keys())
            for key in administratif.keys():
                assert res[key] == administratifs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
            for relation, values in relations:
                assert relation in res
                assert isinstance(res[relation]['etablissement'], ObjectId)
                assert res[relation]['function'] == values[0][0]
                assert res[relation]['discipline'] == values[1][0]
            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            list_keys = administratifs_ad[idx].keys()
            for key, value in query_result[0].items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        values.append(i)
                assert set(values) == set(administratifs_ad[idx][key]), u"valeurs différentes pour la clef : {}".format(key)
            assert not list_keys
        assert list_administratifs == []


def test_eleves():
    for mode, eleves_ad, SambaExport in [('toplevel', eleves_ad_toplevel, SambaToplevel), ('split', eleves_ad_split, SambaSplit)]:
        setup_function(None)
        objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
        relations = [(u'ENTEleveClasses', ['00000001_T STL'])]
        keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id', u'FieldToLDIFFExportActionDate']) | set(objectids)
        for relation in relations:
            keys |= set([relation[0]])
        log = logging.getLogger(__name__)
        #import complet AAF
        main(data_complet, False, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        #import delta AAF
        main_delta(data_delta, close=False)
        samba_import = SambaExport(log, debug=True)
        samba_import.run()
        result = db.fetchall('user', 'UserType', 'eleve')
        list_eleves = eleves.keys()
        for res in result:
            idx = res[u'ENTEleveMEF']
            if idx not in eleves:
                continue
            print "eleve", idx, 'en mode', mode
            list_eleves.remove(idx)
            # we test everything in mongodb
            assert keys == set(res.keys())
            for key in eleve.keys():
                if key != 'ENTEleveCodeEnseignements':
                    assert res[key] == eleves[idx][key], u"la valeur correspondant à : {} est différente".format(key)
                else:
                    assert res[key][0] == u'010300'
                    assert isinstance(res[key][1], ObjectId)
            for objectid in objectids:
                values = res[objectid]
                if isinstance(values, list):
                    for val in values:
                        assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                        #FIXME bon parent ?
                else:
                    assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

            for relation, values in relations:
                assert relation in res
                assert isinstance(res[relation]['etablissement'], ObjectId)
                assert res[relation]['etablissement'] == res['ENTPersonStructRattach']
                assert res[relation]['name'] == values[0]
            # we test what is in the AD
            filter_ = "(&(sAMAccountName=%s)(objectCategory=%s,%s))" % (ldb.binary_encode(res['ENTPersonLogin']),
                      "CN=Person,CN=Schema,CN=Configuration", samba_import.samdb.domain_dn())
            target = samba_import.samdb.search(base=samba_import.samdb.domain_dn(), scope=ldb.SCOPE_SUBTREE,
                                 expression=filter_)
            query_result = list(target)
            assert len(query_result) == 1
            list_keys = eleves_ad[idx].keys()
            for key, value in query_result[0].items():
                values = []
                if key in ['whenCreated', 'whenChanged', 'objectGUID', 'objectSid', 'accountExpires', 'sAMAccountType', 'pwdLastSet', 'uSNChanged', 'uSNCreated']:
                    continue
                list_keys.remove(key)
                if isinstance(value, ldb.Dn):
                    values.append(str(value))
                else:
                    for i in value:
                        values.append(i)
                assert set(values) == set(eleves_ad[idx][key]), u"valeurs différentes pour la clef : {}".format(key)
            assert not list_keys

    assert not list_eleves
